diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-tx-vector.cc ns-3.33/src/wifi/model/wifi-tx-vector.cc
--- ns-3.32/src/wifi/model/wifi-tx-vector.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-tx-vector.cc	2021-01-09 10:19:23.000000000 -0800
@@ -20,6 +20,7 @@
  */
 
 #include "wifi-tx-vector.h"
+#include "ns3/abort.h"
 
 namespace ns3 {
 
@@ -32,6 +33,7 @@
     m_ness (0),
     m_aggregation (false),
     m_stbc (false),
+    m_ldpc (false),
     m_bssColor (0),
     m_modeInitialized (false)
 {
@@ -47,6 +49,7 @@
                             uint16_t channelWidth,
                             bool aggregation,
                             bool stbc,
+                            bool ldpc,
                             uint8_t bssColor)
   : m_mode (mode),
     m_txPowerLevel (powerLevel),
@@ -58,11 +61,42 @@
     m_ness (ness),
     m_aggregation (aggregation),
     m_stbc (stbc),
+    m_ldpc (ldpc),
     m_bssColor (bssColor),
     m_modeInitialized (true)
 {
 }
 
+WifiTxVector::WifiTxVector (const WifiTxVector& txVector)
+  : m_mode (txVector.m_mode),
+    m_txPowerLevel (txVector.m_txPowerLevel),
+    m_preamble (txVector.m_preamble),
+    m_channelWidth (txVector.m_channelWidth),
+    m_guardInterval (txVector.m_guardInterval),
+    m_nTx (txVector.m_nTx),
+    m_nss (txVector.m_nss),
+    m_ness (txVector.m_ness),
+    m_aggregation (txVector.m_aggregation),
+    m_stbc (txVector.m_stbc),
+    m_ldpc (txVector.m_ldpc),
+    m_bssColor (txVector.m_bssColor),
+    m_modeInitialized (txVector.m_modeInitialized)
+{
+  m_muUserInfos.clear ();
+  if (!txVector.m_muUserInfos.empty ()) //avoids crashing for loop
+    {
+      for (auto & info : txVector.m_muUserInfos)
+        {
+          m_muUserInfos.insert (std::make_pair (info.first, info.second));
+        }
+    }
+}
+
+WifiTxVector::~WifiTxVector ()
+{
+  m_muUserInfos.clear ();
+}
+
 bool
 WifiTxVector::GetModeInitialized (void) const
 {
@@ -70,12 +104,18 @@
 }
 
 WifiMode
-WifiTxVector::GetMode (void) const
+WifiTxVector::GetMode (uint16_t staId) const
 {
   if (!m_modeInitialized)
     {
       NS_FATAL_ERROR ("WifiTxVector mode must be set before using");
     }
+  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+    {
+      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
+      NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
+      return m_muUserInfos.at (staId).mcs;
+    }
   return m_mode;
 }
 
@@ -110,12 +150,36 @@
 }
 
 uint8_t
-WifiTxVector::GetNss (void) const
+WifiTxVector::GetNss (uint16_t staId) const
 {
+  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+    {
+      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
+      NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
+      return m_muUserInfos.at (staId).nss;
+    }
   return m_nss;
 }
 
 uint8_t
+WifiTxVector::GetNssMax (void) const
+{
+  uint8_t nss = 0;
+  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+    {
+      for (const auto & info : m_muUserInfos)
+        {
+          nss = (nss < info.second.nss) ? info.second.nss : nss;
+        }
+    }
+  else
+    {
+      nss = m_nss;
+    }
+  return nss;
+}
+
+uint8_t
 WifiTxVector::GetNess (void) const
 {
   return m_ness;
@@ -133,6 +197,12 @@
   return m_stbc;
 }
 
+bool
+WifiTxVector::IsLdpc (void) const
+{
+  return m_ldpc;
+}
+
 void
 WifiTxVector::SetMode (WifiMode mode)
 {
@@ -141,6 +211,15 @@
 }
 
 void
+WifiTxVector::SetMode (WifiMode mode, uint16_t staId)
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "Not an HE MU transmission");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  m_muUserInfos[staId].mcs = mode;
+  m_modeInitialized = true;
+}
+
+void
 WifiTxVector::SetTxPowerLevel (uint8_t powerlevel)
 {
   m_txPowerLevel = powerlevel;
@@ -177,6 +256,14 @@
 }
 
 void
+WifiTxVector::SetNss (uint8_t nss, uint16_t staId)
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "Not an HE MU transmission");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  m_muUserInfos[staId].nss = nss;
+}
+
+void
 WifiTxVector::SetNess (uint8_t ness)
 {
   m_ness = ness;
@@ -195,6 +282,12 @@
 }
 
 void
+WifiTxVector::SetLdpc (bool ldpc)
+{
+  m_ldpc = ldpc;
+}
+
+void
 WifiTxVector::SetBssColor (uint8_t color)
 {
   m_bssColor = color;
@@ -242,18 +335,79 @@
   return true;
 }
 
+HeRu::RuSpec
+WifiTxVector::GetRu (uint16_t staId) const
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "RU only available for MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  return m_muUserInfos.at (staId).ru;
+}
+
+void
+WifiTxVector::SetRu (HeRu::RuSpec ru, uint16_t staId)
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "RU only available for MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  m_muUserInfos[staId].ru = ru;
+}
+
+HeMuUserInfo
+WifiTxVector::GetHeMuUserInfo (uint16_t staId) const
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info only available for MU");
+  return m_muUserInfos.at (staId);
+}
+
+void
+WifiTxVector::SetHeMuUserInfo (uint16_t staId, HeMuUserInfo userInfo)
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info only available for MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  NS_ABORT_MSG_IF (userInfo.mcs.GetModulationClass () != WIFI_MOD_CLASS_HE, "Only HE modes authorized for HE MU");
+  m_muUserInfos[staId] = userInfo;
+  m_modeInitialized = true;
+}
+
+const WifiTxVector::HeMuUserInfoMap&
+WifiTxVector::GetHeMuUserInfoMap (void) const
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info map only available for MU");
+  return m_muUserInfos;
+}
+
 std::ostream & operator << ( std::ostream &os, const WifiTxVector &v)
 {
-  os << "mode: " << v.GetMode () <<
-    " txpwrlvl: " << +v.GetTxPowerLevel () <<
-    " preamble: " << v.GetPreambleType () <<
-    " channel width: " << v.GetChannelWidth () <<
-    " GI: " << v.GetGuardInterval () <<
-    " NTx: " << +v.GetNTx () <<
-    " Nss: " << +v.GetNss () <<
-    " Ness: " << +v.GetNess () <<
-    " MPDU aggregation: " << v.IsAggregation () <<
-    " STBC: " << v.IsStbc ();
+  if (!v.IsValid ())
+    {
+      os << "TXVECTOR not valid";
+      return os;
+    }
+  os << "txpwrlvl: " << +v.GetTxPowerLevel ()
+     << " preamble: " << v.GetPreambleType ()
+     << " channel width: " << v.GetChannelWidth ()
+     << " GI: " << v.GetGuardInterval ()
+     << " NTx: " << +v.GetNTx ()
+     << " Ness: " << +v.GetNess ()
+     << " MPDU aggregation: " << v.IsAggregation ()
+     << " STBC: " << v.IsStbc ()
+     << " FEC coding: " << (v.IsLdpc () ? "LDPC" : "BCC");
+  if (v.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+    {
+      WifiTxVector::HeMuUserInfoMap userInfoMap = v.GetHeMuUserInfoMap ();
+      os << " num User Infos: " << userInfoMap.size ();
+      for (auto & ui : userInfoMap)
+        {
+          os << ", {STA-ID: " << ui.first
+             << ", " << ui.second.ru
+             << ", MCS: " << ui.second.mcs
+             << ", Nss: " << +ui.second.nss << "}";
+        }
+    }
+  else
+    {
+      os << " mode: " << v.GetMode ()
+         << " Nss: " << +v.GetNss ();
+    }
   return os;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-tx-vector.h ns-3.33/src/wifi/model/wifi-tx-vector.h
--- ns-3.32/src/wifi/model/wifi-tx-vector.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-tx-vector.h	2021-01-09 10:19:23.000000000 -0800
@@ -22,11 +22,20 @@
 #ifndef WIFI_TX_VECTOR_H
 #define WIFI_TX_VECTOR_H
 
+#include <list>
 #include "wifi-mode.h"
 #include "wifi-preamble.h"
+#include "he-ru.h"
 
 namespace ns3 {
 
+/// HE MU specific user transmission parameters.
+struct HeMuUserInfo
+{
+  HeRu::RuSpec ru; ///< RU specification
+  WifiMode mcs;    ///< MCS
+  uint8_t nss;     ///< number of spatial streams
+};
 
 /**
  * This class mimics the TXVECTOR which is to be
@@ -61,7 +70,11 @@
 class WifiTxVector
 {
 public:
+  /// map of HE MU specific user info paramters indexed by STA-ID
+  typedef std::map <uint16_t /* staId */, HeMuUserInfo /* HE MU specific user info */> HeMuUserInfoMap;
+
   WifiTxVector ();
+  ~WifiTxVector ();
   /**
    * Create a TXVECTOR with the given parameters.
    *
@@ -75,6 +88,7 @@
    * \param channelWidth the channel width in MHz
    * \param aggregation enable or disable MPDU aggregation
    * \param stbc enable or disable STBC
+   * \param ldpc enable or disable LDPC (BCC is used otherwise)
    * \param bssColor the BSS color
    */
   WifiTxVector (WifiMode mode,
@@ -86,16 +100,29 @@
                 uint8_t ness,
                 uint16_t channelWidth,
                 bool aggregation,
-                bool stbc,
+                bool stbc = false,
+                bool ldpc = false,
                 uint8_t bssColor = 0);
   /**
+   * Copy constructor
+   * \param txVector the TXVECTOR to copy
+   */
+  WifiTxVector (const WifiTxVector& txVector);
+
+  /**
    * \returns whether mode has been initialized
    */
   bool GetModeInitialized (void) const;
   /**
+   * If this TX vector is associated with an SU PPDU, return the selected
+   * payload transmission mode. If this TX vector is associated with an
+   * MU PPDU, return the transmission mode (MCS) selected for the transmission
+   * to the station identified by the given STA-ID.
+   *
+   * \param staId the station ID for HE MU
    * \returns the selected payload transmission mode
    */
-  WifiMode GetMode (void) const;
+  WifiMode GetMode (uint16_t staId = SU_STA_ID) const;
   /**
   * Sets the selected payload transmission mode
   *
@@ -103,6 +130,14 @@
   */
   void SetMode (WifiMode mode);
   /**
+  * Sets the selected payload transmission mode for a given STA ID (for HE MU only)
+  *
+  * \param mode
+   * \param staId the station ID for HE MU
+  */
+  void SetMode (WifiMode mode, uint16_t staId);
+
+  /**
    * \returns the transmission power level
    */
   uint8_t GetTxPowerLevel (void) const;
@@ -153,21 +188,38 @@
    */
   void SetNTx (uint8_t nTx);
   /**
+   * If this TX vector is associated with an SU PPDU, return the number of
+   * spatial streams. If this TX vector is associated with an MU PPDU,
+   * return the number of spatial streams for the transmission to the station
+   * identified by the given STA-ID.
+   *
+   * \param staId the station ID for HE MU
    * \returns the number of spatial streams
    */
-  uint8_t GetNss (void) const;
+  uint8_t GetNss (uint16_t staId = SU_STA_ID) const;
   /**
-   * Sets the number of Nss refer to IEEE 802.11n Table 20-28 for explanation and range
+   * \returns the maximum number of Nss (namely if HE MU)
+   */
+  uint8_t GetNssMax (void) const;
+  /**
+   * Sets the number of Nss
    *
    * \param nss the number of spatial streams
    */
   void SetNss (uint8_t nss);
   /**
+   * Sets the number of Nss for HE MU
+   *
+   * \param nss the number of spatial streams
+   * \param staId the station ID for HE MU
+   */
+  void SetNss (uint8_t nss, uint16_t staId);
+  /**
    * \returns the number of extended spatial streams
    */
   uint8_t GetNess (void) const;
   /**
-   * Sets the Ness number refer to IEEE 802.11n Table 20-6 for explanation
+   * Sets the Ness number
    *
    * \param ness the number of extended spatial streams
    */
@@ -198,6 +250,19 @@
    */
   void SetStbc (bool stbc);
   /**
+   * Check if LDPC FEC coding is used or not
+   *
+   * \returns true if LDPC is used,
+   *          false if BCC is used
+   */
+  bool IsLdpc (void) const;
+  /**
+   * Sets if LDPC FEC coding is being used
+   *
+   * \param ldpc enable or disable LDPC
+   */
+  void SetLdpc (bool ldpc);
+  /**
    * Set the BSS color
    * \param color the BSS color
    */
@@ -215,6 +280,45 @@
    * \return true if the WifiTxVector parameters are allowed by the standard
    */
   bool IsValid (void) const;
+   /**
+    * Get the RU specification for the STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \param staId the station ID
+    * \return the RU specification for the STA-ID
+    */
+   HeRu::RuSpec GetRu (uint16_t staId) const;
+   /**
+    * Set the RU specification for the STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \param ru the RU specification
+    * \param staId the station ID
+    */
+   void SetRu (HeRu::RuSpec ru, uint16_t staId);
+   /**
+    * Get the HE MU user-specific transmission information for the given STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \param staId the station ID
+    * \return the HE MU user-specific transmission information for the given STA-ID
+    */
+   HeMuUserInfo GetHeMuUserInfo (uint16_t staId) const;
+   /**
+    * Set the HE MU user-specific transmission information for the given STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \param staId the station ID
+    * \param userInfo the HE MU user-specific transmission information
+    */
+   void SetHeMuUserInfo (uint16_t staId, HeMuUserInfo userInfo);
+   /**
+    * Get the map HE MU user-specific transmission information indexed by STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \return the map of HE MU user-specific information indexed by STA-ID
+    */
+   const HeMuUserInfoMap& GetHeMuUserInfoMap (void) const;
 
 
 private:
@@ -232,9 +336,16 @@
   uint8_t  m_ness;               /**< number of spatial streams in beamforming */
   bool     m_aggregation;        /**< Flag whether the PSDU contains A-MPDU. */
   bool     m_stbc;               /**< STBC used or not */
+  bool     m_ldpc;               /**< LDPC FEC coding if true, BCC otherwise*/
   uint8_t  m_bssColor;           /**< BSS color */
 
   bool     m_modeInitialized;         /**< Internal initialization flag */
+
+  //MU information
+  HeMuUserInfoMap m_muUserInfos; /**< HE MU specific per-user information
+                                      indexed by station ID (STA-ID) corresponding
+                                      to the 11 LSBs of the AID of the recipient STA
+                                      This list shall be used only for HE MU */
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-utils.cc ns-3.33/src/wifi/model/wifi-utils.cc
--- ns-3.32/src/wifi/model/wifi-utils.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-utils.cc	2021-01-09 10:19:23.000000000 -0800
@@ -264,4 +264,22 @@
   return duration;
 }
 
+bool
+IsHt (WifiPreamble preamble)
+{
+   return (preamble == WIFI_PREAMBLE_HT_MF || preamble == WIFI_PREAMBLE_HT_GF);
+}
+
+bool
+IsVht (WifiPreamble preamble)
+{
+   return (preamble == WIFI_PREAMBLE_VHT_SU || preamble == WIFI_PREAMBLE_VHT_MU);
+}
+
+bool
+IsHe (WifiPreamble preamble)
+{
+   return (preamble == WIFI_PREAMBLE_HE_SU || preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB || preamble == WIFI_PREAMBLE_HE_ER_SU);
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/wifi-utils.h ns-3.33/src/wifi/model/wifi-utils.h
--- ns-3.32/src/wifi/model/wifi-utils.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/wifi-utils.h	2021-01-09 10:19:23.000000000 -0800
@@ -183,6 +183,34 @@
  */
 Time GetPpduMaxTime (WifiPreamble preamble);
 
+/**
+ * Return whether the preamble is a HT format preamble.
+ *
+ * \param preamble the preamble type
+ *
+ * \return true if the preamble is a HT format preamble,
+ *         false otherwise
+ */
+bool IsHt (WifiPreamble preamble);
+/**
+ * Return whether the preamble is a VHT format preamble.
+ *
+ * \param preamble the preamble type
+ *
+ * \return true if the preamble is a VHT format preamble,
+ *         false otherwise
+ */
+bool IsVht (WifiPreamble preamble);
+/**
+ * Return whether the preamble is a HE format preamble.
+ *
+ * \param preamble the preamble type
+ *
+ * \return true if the preamble is a HE format preamble,
+ *         false otherwise
+ */
+bool IsHe (WifiPreamble preamble);
+
 /// Size of the space of sequence numbers
 const uint16_t SEQNO_SPACE_SIZE = 4096;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/yans-error-rate-model.cc ns-3.33/src/wifi/model/yans-error-rate-model.cc
--- ns-3.32/src/wifi/model/yans-error-rate-model.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/yans-error-rate-model.cc	2021-01-09 10:19:23.000000000 -0800
@@ -21,7 +21,6 @@
 
 #include "ns3/log.h"
 #include "yans-error-rate-model.h"
-#include "dsss-error-rate-model.h"
 #include "wifi-utils.h"
 #include "wifi-phy.h"
 
@@ -180,7 +179,7 @@
 }
 
 double
-YansErrorRateModel::GetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const
+YansErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const
 {
   NS_LOG_FUNCTION (this << mode << txVector.GetMode () << snr << nbits);
   if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM
@@ -352,22 +351,6 @@
             }
         }
     }
-  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS || mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS)
-    {
-      switch (mode.GetDataRate (20))
-        {
-        case 1000000:
-          return DsssErrorRateModel::GetDsssDbpskSuccessRate (snr, nbits);
-        case 2000000:
-          return DsssErrorRateModel::GetDsssDqpskSuccessRate (snr, nbits);
-        case 5500000:
-          return DsssErrorRateModel::GetDsssDqpskCck5_5SuccessRate (snr, nbits);
-        case 11000000:
-          return DsssErrorRateModel::GetDsssDqpskCck11SuccessRate (snr, nbits);
-        default:
-          NS_ASSERT ("undefined DSSS/HR-DSSS datarate");
-        }
-    }
   return 0;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/yans-error-rate-model.h ns-3.33/src/wifi/model/yans-error-rate-model.h
--- ns-3.32/src/wifi/model/yans-error-rate-model.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/yans-error-rate-model.h	2021-01-09 10:19:23.000000000 -0800
@@ -61,10 +61,10 @@
 
   YansErrorRateModel ();
 
-  virtual double GetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const;
-
 
 private:
+  //Inherited from ErrorRateModel
+  double DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const;
   /**
    * Return BER of BPSK with the given parameters.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/yans-wifi-channel.cc ns-3.33/src/wifi/model/yans-wifi-channel.cc
--- ns-3.32/src/wifi/model/yans-wifi-channel.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/yans-wifi-channel.cc	2021-01-09 10:19:23.000000000 -0800
@@ -133,7 +133,9 @@
       NS_LOG_INFO ("Received signal too weak to process: " << rxPowerDbm << " dBm");
       return;
     }
-  phy->StartReceivePreamble (ppdu, DbmToW (rxPowerDbm + phy->GetRxGain ()));
+  RxPowerWattPerChannelBand rxPowerW;
+  rxPowerW.insert ({std::make_pair (0, 0), (DbmToW (rxPowerDbm + phy->GetRxGain ()))}); //dummy band for YANS
+  phy->StartReceivePreamble (ppdu, rxPowerW);
 }
 
 std::size_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/yans-wifi-phy.cc ns-3.33/src/wifi/model/yans-wifi-phy.cc
--- ns-3.32/src/wifi/model/yans-wifi-phy.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/yans-wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
@@ -45,6 +45,11 @@
 YansWifiPhy::YansWifiPhy ()
 {
   NS_LOG_FUNCTION (this);
+  //add dummy band for Yans
+  WifiSpectrumBand band;
+  band.first = 0;
+  band.second = 0;
+  m_interference.AddBand (band);
 }
 
 YansWifiPhy::~YansWifiPhy ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/test/block-ack-test-suite.cc ns-3.33/src/wifi/test/block-ack-test-suite.cc
--- ns-3.32/src/wifi/test/block-ack-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/test/block-ack-test-suite.cc	2021-01-09 10:19:23.000000000 -0800
@@ -711,8 +711,9 @@
    * Callback invoked when PHY receives a packet
    * \param context the context
    * \param p the packet
+   * \param rxPowersW the received power per channel band in watts
    */
-  void Receive (std::string context, Ptr<const Packet> p);
+  void Receive (std::string context, Ptr<const Packet> p, RxPowerWattPerChannelBand rxPowersW);
 };
 
 void
@@ -788,7 +789,7 @@
 }
 
 void
-BlockAckAggregationDisabledTest::Receive (std::string context, Ptr<const Packet> p)
+BlockAckAggregationDisabledTest::Receive (std::string context, Ptr<const Packet> p, RxPowerWattPerChannelBand rxPowersW)
 {
   WifiMacHeader hdr;
   p->PeekHeader (hdr);
@@ -809,7 +810,7 @@
   wifiApNode.Create (1);
 
   YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper phy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/test/inter-bss-test-suite.cc ns-3.33/src/wifi/test/inter-bss-test-suite.cc
--- ns-3.32/src/wifi/test/inter-bss-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/test/inter-bss-test-suite.cc	2021-01-09 10:19:23.000000000 -0800
@@ -40,7 +40,7 @@
 
 NS_LOG_COMPONENT_DEFINE ("InterBssTestSuite");
 
-uint32_t
+static uint32_t
 ConvertContextToNodeId (std::string context)
 {
   std::string sub = context.substr (10);
@@ -422,7 +422,7 @@
   Ptr<MatrixPropagationLossModel> lossModel = CreateObject<MatrixPropagationLossModel> ();
   lossModel->SetDefaultLoss (m_txPowerDbm - m_obssRxPowerDbm); //Force received RSSI to be equal to m_obssRxPowerDbm
 
-  SpectrumWifiPhyHelper phy = SpectrumWifiPhyHelper::Default ();
+  SpectrumWifiPhyHelper phy;
   phy.DisablePreambleDetectionModel ();
   Ptr<MultiModelSpectrumChannel> channel = CreateObject<MultiModelSpectrumChannel> ();
   channel->SetPropagationDelayModel (CreateObject<ConstantSpeedPropagationDelayModel> ());
@@ -515,7 +515,7 @@
   m_bssColor3 = 3;
   RunOne ();
 
-  //Test case 3: CCA CS Threshold = < m_obssPdLevelDbm = m_obssRxPowerDbm
+  //Test case 3: CCA CS Threshold < m_obssPdLevelDbm = m_obssRxPowerDbm
   m_obssPdLevelDbm = -72;
   m_obssRxPowerDbm = -72;
   m_bssColor1 = 1;
